<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/parser/features/suggestions.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>suggestions.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;suggestions&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">std::cmp::Ordering</span>;

<span class="comment">// Internal</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::builder::Command</span>;

<span class="doccomment">/// Produces multiple strings from a given list of possible values which are similar</span>
<span class="doccomment">/// to the passed in value `v` within a certain confidence by least confidence.</span>
<span class="doccomment">/// Thus in a list of possible values like [&quot;foo&quot;, &quot;bar&quot;], the value &quot;fop&quot; will yield</span>
<span class="doccomment">/// `Some(&quot;foo&quot;)`, whereas &quot;blark&quot; would yield `None`.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;suggestions&quot;</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">did_you_mean</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">I</span><span class="op">&gt;</span>(<span class="ident">v</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">possible_values</span>: <span class="ident">I</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span><span class="ident">str</span><span class="op">&gt;</span>,
    <span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">candidates</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">f64</span>, <span class="ident">String</span>)<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">possible_values</span>
        .<span class="ident">into_iter</span>()
        .<span class="ident">map</span>(<span class="op">|</span><span class="ident">pv</span><span class="op">|</span> (<span class="ident">strsim::jaro_winkler</span>(<span class="ident">v</span>, <span class="ident">pv</span>.<span class="ident">as_ref</span>()), <span class="ident">pv</span>.<span class="ident">as_ref</span>().<span class="ident">to_owned</span>()))
        .<span class="ident">filter</span>(<span class="op">|</span>(<span class="ident">confidence</span>, <span class="kw">_</span>)<span class="op">|</span> <span class="kw-2">*</span><span class="ident">confidence</span> <span class="op">&gt;</span> <span class="number">0.8</span>)
        .<span class="ident">collect</span>();
    <span class="ident">candidates</span>.<span class="ident">sort_by</span>(<span class="op">|</span><span class="ident">a</span>, <span class="ident">b</span><span class="op">|</span> <span class="ident">a</span>.<span class="number">0</span>.<span class="ident">partial_cmp</span>(<span class="kw-2">&amp;</span><span class="ident">b</span>.<span class="number">0</span>).<span class="ident">unwrap_or</span>(<span class="ident">Ordering::Equal</span>));
    <span class="ident">candidates</span>.<span class="ident">into_iter</span>().<span class="ident">map</span>(<span class="op">|</span>(<span class="kw">_</span>, <span class="ident">pv</span>)<span class="op">|</span> <span class="ident">pv</span>).<span class="ident">collect</span>()
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;suggestions&quot;</span>))]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">did_you_mean</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">I</span><span class="op">&gt;</span>(<span class="kw">_</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="kw">_</span>: <span class="ident">I</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span><span class="ident">str</span><span class="op">&gt;</span>,
    <span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="ident">Vec::new</span>()
}

<span class="doccomment">/// Returns a suffix that can be empty, or is the standard &#39;did you mean&#39; phrase</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">did_you_mean_flag</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;help</span>, <span class="ident">I</span>, <span class="ident">T</span><span class="op">&gt;</span>(
    <span class="ident">arg</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>,
    <span class="ident">remaining_args</span>: <span class="kw-2">&amp;</span>[<span class="kw-2">&amp;</span><span class="ident">str</span>],
    <span class="ident">longs</span>: <span class="ident">I</span>,
    <span class="ident">subcommands</span>: <span class="kw">impl</span> <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Command</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span><span class="op">&gt;</span>,
) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">String</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>)<span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="lifetime">&#39;help</span>: <span class="lifetime">&#39;a</span>,
    <span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span><span class="ident">str</span><span class="op">&gt;</span>,
    <span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::mkeymap::KeyType</span>;

    <span class="kw">match</span> <span class="ident">did_you_mean</span>(<span class="ident">arg</span>, <span class="ident">longs</span>).<span class="ident">pop</span>() {
        <span class="prelude-val">Some</span>(<span class="ident">candidate</span>) =&gt; <span class="prelude-val">Some</span>((<span class="ident">candidate</span>, <span class="prelude-val">None</span>)),
        <span class="prelude-val">None</span> =&gt; <span class="ident">subcommands</span>
            .<span class="ident">into_iter</span>()
            .<span class="ident">filter_map</span>(<span class="op">|</span><span class="ident">subcommand</span><span class="op">|</span> {
                <span class="ident">subcommand</span>.<span class="ident">_build_self</span>();

                <span class="kw">let</span> <span class="ident">longs</span> <span class="op">=</span> <span class="ident">subcommand</span>.<span class="ident">get_keymap</span>().<span class="ident">keys</span>().<span class="ident">filter_map</span>(<span class="op">|</span><span class="ident">a</span><span class="op">|</span> {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="ident">KeyType::Long</span>(<span class="ident">v</span>) <span class="op">=</span> <span class="ident">a</span> {
                        <span class="prelude-val">Some</span>(<span class="ident">v</span>.<span class="ident">to_string_lossy</span>().<span class="ident">into_owned</span>())
                    } <span class="kw">else</span> {
                        <span class="prelude-val">None</span>
                    }
                });

                <span class="kw">let</span> <span class="ident">subcommand_name</span> <span class="op">=</span> <span class="ident">subcommand</span>.<span class="ident">get_name</span>();

                <span class="kw">let</span> <span class="ident">candidate</span> <span class="op">=</span> <span class="ident">did_you_mean</span>(<span class="ident">arg</span>, <span class="ident">longs</span>).<span class="ident">pop</span>()<span class="question-mark">?</span>;
                <span class="kw">let</span> <span class="ident">score</span> <span class="op">=</span> <span class="ident">remaining_args</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">==</span> <span class="ident">subcommand_name</span>)<span class="question-mark">?</span>;
                <span class="prelude-val">Some</span>((<span class="ident">score</span>, (<span class="ident">candidate</span>, <span class="prelude-val">Some</span>(<span class="ident">subcommand_name</span>.<span class="ident">to_string</span>()))))
            })
            .<span class="ident">min_by_key</span>(<span class="op">|</span>(<span class="ident">x</span>, <span class="kw">_</span>)<span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span>)
            .<span class="ident">map</span>(<span class="op">|</span>(<span class="kw">_</span>, <span class="ident">suggestion</span>)<span class="op">|</span> <span class="ident">suggestion</span>),
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">features</span> <span class="op">=</span> <span class="string">&quot;suggestions&quot;</span>))]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">possible_values_match</span>() {
        <span class="kw">let</span> <span class="ident">p_vals</span> <span class="op">=</span> [<span class="string">&quot;test&quot;</span>, <span class="string">&quot;possible&quot;</span>, <span class="string">&quot;values&quot;</span>];
        <span class="macro">assert_eq!</span>(<span class="ident">did_you_mean</span>(<span class="string">&quot;tst&quot;</span>, <span class="ident">p_vals</span>.<span class="ident">iter</span>()), <span class="prelude-val">Some</span>(<span class="string">&quot;test&quot;</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">possible_values_match</span>() {
        <span class="kw">let</span> <span class="ident">p_vals</span> <span class="op">=</span> [<span class="string">&quot;test&quot;</span>, <span class="string">&quot;temp&quot;</span>];
        <span class="macro">assert_eq!</span>(<span class="ident">did_you_mean</span>(<span class="string">&quot;te&quot;</span>, <span class="ident">p_vals</span>.<span class="ident">iter</span>()), <span class="prelude-val">Some</span>(<span class="string">&quot;test&quot;</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">possible_values_nomatch</span>() {
        <span class="kw">let</span> <span class="ident">p_vals</span> <span class="op">=</span> [<span class="string">&quot;test&quot;</span>, <span class="string">&quot;possible&quot;</span>, <span class="string">&quot;values&quot;</span>];
        <span class="macro">assert!</span>(<span class="ident">did_you_mean</span>(<span class="string">&quot;hahaahahah&quot;</span>, <span class="ident">p_vals</span>.<span class="ident">iter</span>()).<span class="ident">is_none</span>());
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">flag</span>() {
        <span class="kw">let</span> <span class="ident">p_vals</span> <span class="op">=</span> [<span class="string">&quot;test&quot;</span>, <span class="string">&quot;possible&quot;</span>, <span class="string">&quot;values&quot;</span>];
        <span class="macro">assert_eq!</span>(
            <span class="ident">did_you_mean_flag</span>(<span class="string">&quot;tst&quot;</span>, <span class="ident">p_vals</span>.<span class="ident">iter</span>(), []),
            <span class="prelude-val">Some</span>((<span class="string">&quot;test&quot;</span>, <span class="prelude-val">None</span>))
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>